{-# LANGUAGE LambdaCase #-}
module Connection where

import Prelude hiding (log)
import Hakka.Actor
import Messages
import Control.Concurrent.MVar

connection n = actor ("connection" ++ show n) receive where
  receive = \case
    Connect out res -> do
      log Info "new client connected"            
      self >>= liftIO . putMVar res
      become $ connected out
    Disconnect -> do
      log Info "connection closed"
      stop
  connected send = \case
    Msg (TimestampedMessage t m) -> do
      log Info $ "received: " ++ show m ++ " at " ++ show t
      case m of
        Ping -> liftIO $ do
          answer <- timestamped Pong
          send answer